=== debian/changelog ===
vtk9 (9.5.2+dfsg2-4ubuntu2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 27 Jan 2026 12:00:21 +0000

vtk9 (9.5.2+dfsg2-4ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Build with openjdk-17 to avoid a JVM crash on s390x.
    - libvtk9-dev: Also depend on openjdk-17 on s390x.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 14 Dec 2025 11:12:17 +0000

vtk9 (9.5.2+dfsg2-4) unstable; urgency=medium

  * Team upload
  * Enable VTK external rendering with SDL, GLFW, etc.

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 27 Oct 2025 14:54:02 -0400

vtk9 (9.5.2+dfsg2-3) unstable; urgency=medium

  * Team upload
  * Fix vtk9-doc FTBFS

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 23 Oct 2025 20:23:59 -0400

vtk9 (9.5.2+dfsg2-2) unstable; urgency=medium

  * Team upload
  * Fix manpages suffix

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 23 Oct 2025 14:27:19 -0400

vtk9 (9.5.2+dfsg2-1) unstable; urgency=medium

  * Team upload
  * New upstream release 9.5.2+dfsg2
  * Keep embedded viskores and scn sources
  * Exclude embedded nlohmannjson/vtknlohmannjson sources
  * d/copyright: Update files and licenses
  * Raise minimum Java version from 8 to 11 (javac --release 11)
  * Add nlohmann-json3-dev dependency
  * Add PPC64 patch
  * Lower optimization to -O1 on alpha to fix FTBFS
  * Bump Standards-Version to 4.7.2
  * Drop outdated patches
  * Remove hardcoded compiler flags
  * Update man pages
  * Switch to Qt6

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 13 Oct 2025 12:11:48 -0400

vtk9 (9.3.0+dfsg1-4ubuntu2) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 May 2025 05:51:47 +0200

vtk9 (9.3.0+dfsg1-4ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Build with openjdk-17 to avoid a JVM crash on s390x.
    - libvtk9-dev: Also depend on openjdk-17 on s390x.
  * Drop Changes:
    - Python 3.13 fix for missing dict segfault (closes: #1092083).
      [Fixed in 9.3.0+dfsg1-3]

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 18 Feb 2025 23:08:25 +0000

vtk9 (9.3.0+dfsg1-1.1ubuntu4) plucky; urgency=medium

  * No-change rebuild for libnetcdf22.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 18 Feb 2025 16:17:21 +0000

vtk9 (9.3.0+dfsg1-1.1ubuntu3) plucky; urgency=medium

  * No-change rebuild against libhdf5-310

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 28 Jan 2025 09:41:04 +0000

vtk9 (9.3.0+dfsg1-1.1ubuntu2) plucky; urgency=medium

  * libvtk9-dev: Also depend on openjdk-17 on s390x.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 09 Jan 2025 14:41:18 +0100

vtk9 (9.3.0+dfsg1-1.1ubuntu1) plucky; urgency=medium

  [ Matthias Klose ]
  * Build with openjdk-17 to avoid a JVM crash on s390x.

  [ Colin Watson ]
  * Python 3.13 fix for missing dict segfault (closes: #1092083).

 -- Matthias Klose <doko@ubuntu.com>  Wed, 08 Jan 2025 12:52:28 +0100

vtk9 (9.3.0+dfsg1-1.1build3) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 04 Jan 2025 05:16:55 +0100

vtk9 (9.3.0+dfsg1-1.1build2) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 01 Dec 2024 21:55:50 +0100

vtk9 (9.3.0+dfsg1-1.1build1) plucky; urgency=medium

  * No-change rebuild for openmpi soname change

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 01 Dec 2024 16:22:11 +0000
