## vtk9 9.5.2%2Bdfsg3

=== debian/watch ===
Version: 5

Template: GitLab
Dist: https://gitlab.kitware.com/vtk/vtk
Repacksuffix: +dfsg1
Dversion-Mangle: auto
