=== GUISupport/QtQuick/Testing/CMakeLists.txt ===
vtk_module_test_data(
  Data/vase_1comp.vti)

add_subdirectory(Cxx)
