=== debian/changelog ===
vtk9 (9.5.2+dfsg1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 9.5.2+dfsg1
  * d/copyright: Update files and licenses
  * Add nlohmann-json3-dev dependency
  * Drop outdated patches
  * Remove hardcoded compiler flags
  * Raise minimum Java version from 8 to 17 (javac --release 17)
  * Bump Standards-Version to 4.7.2
  * Switch from Qt5 to Qt6

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 23 Sep 2025 16:48:13 -0400
